<?php

$debug=0;

include("sprintpcscommon.php");

/********************************************/
/* Process arguments                        */
/********************************************/

if (array_key_exists("PROFILE",$_GET))
     $profile=$_GET["PROFILE"];
else
     die('No profile!');

// prevent them from passing us scary profiles.
$profile=preg_replace("/[\\\\.:~\\\\]/", "", $profile);

if (array_key_exists("DAYSBACK",$_GET))
     $daysback=$_GET["DAYSBACK"];
else
     $daysback=30;

if (array_key_exists("WIDTH",$_GET))
     $width=$_GET["WIDTH"];
     else
     $width=200;

if (array_key_exists("HEIGHT",$_GET))
     $height=$_GET["HEIGHT"];
     else
     $height=150;

/*

We're going to create a graph, doing some intelligent scaling as we go
along.

*/

$confpath=$SPRINTPREFIX.$profile.".conf";
$conf=readconfig($confpath);
$historypath=$SPRINTPREFIX.$profile."history.txt";
$d=readhistoryfile($historypath);

$im=imagecreate($width,$height+$extraheight);

$minutetypes=array(array("type"=>"MINUTES IN PLAN",
			 "color"=>imagecolorallocate($im,255,255,0)),

		   array("type"=>"OFF-PEAK OPTION",
			 "color"=>imagecolorallocate($im,128,128,255)),

		   array("type"=>"LONG DISTANCE",
			 "color"=>imagecolorallocate($im,255,0,0)),

		   array("type"=>"OTHER",
			 "color"=>imagecolorallocate($im,0,128,128))
		   );

$maxplan=0;
foreach ($minutetypes as $k=>$minutetype)
{
  $minutetypes[$k]["maxminutes"]=maximumminutes($d, $minutetype["type"]);
  $minutetypes[$k]["maxplanminutes"]=maximumplanminutes($d, $minutetype["type"]);

  $maxplan=max($maxplan,$minutetypes[$k]["maxplanminutes"]);
}

foreach($minutetypes as $k=>$minutetype)
{
  $minutetypes[$k]["scale"]=$height/($minutetype["maxminutes"]+1);
}

$daywidth=$width/$daysback;

//print "$daywidth $width $daysback";

$extraheight=imagefontheight(2)*2;

$white=imagecolorallocate($im,255,255,255);
$black=imagecolorallocate($im,0,0,0);
$yellow=imagecolorallocate($im,255,255,0);
$blue=imagecolorallocate($im,200,80,255);
$red=imagecolorallocate($im,255,0,0);
$dkgray=imagecolorallocate($im,45,45,45);
imagefilledrectangle($im,0,0,$width,$height+$extraheight,$black);
//imagecolortransparent($im,$black);

$bgpattern=array($black,$black,$black,
		 $red,$red,$red);

imagesetstyle($im,$bgpattern);

$todaytime=time();
$todaydate=getdate($todaytime);

$starttime=$todaytime-60*60*24*$daysback;
$startdate=getdate($starttime);
$starttime=mktime(0,0,0,$startdate["mon"],$startdate["mday"],$startdate["year"]);
$endtime=$todaytime;

$todaytime=mktime(23,59,59,$todaydate["mon"],$todaydate["mday"],$todaydate["year"]);

//print date("r",$starttime)." ".date("r",$todaytime);

/***************************************************
 *  Draw everything!                               *
 ***************************************************/

/** draw dark grey vertical bars every 24 hours. */
for ($i=0;$i<$daysback+1;$i++)
{
  $t=$todaytime-$i*3600*24;
  $x=$width-$width*($t-$starttime)/($todaytime-$starttime);
  //    print " $x <br>";
  imageline($im,$x,0,$x,$height,$dkgray);
}

/** Draw bars along the Y axis **/
/** draw vertical scale */
$steps=5;
for ($i=0;$i<=$steps;$i++)
{
  $frac=$i/$steps;
  $y=$height-$frac*$height;
  $x=2;

  foreach ($minutetypes as $minutetype)
    {
      $mins=intval($frac*$minutetype["maxminutes"]);
      if ($mins>0)
	imagestring($im,2,$x,$y,intval($mins),$minutetype["color"]);
      $x=$x+30;
    }

  imageline($im,0,$y,$width,$y,$dkgray);
}

/* draw legend across top */
$x=$width;
foreach ($minutetypes as $minutetype)
{
  $mins=intval($frac*$minutetype["maxminutes"]);
  if ($mins>0)
    {
      $x=$x-imagefontwidth(2)*1;
      $x=$x-imagefontwidth(2)*strlen($minutetype["type"]);
      imagestring($im,2,$x,0,ucwords(strtolower($minutetype["type"])),
		  $minutetype["color"]);
      $x=$x-imagefontwidth(2)*2;
    }
}

/** Draw the expected usage bars **/

foreach ($d as $data)
{
  if (array_key_exists("updatetime",$data))
    $time=$data["updatetime"];
  else if (array_key_exists("currentasoftime", $data))
    $time=$data["currentasoftime"];
  else
    continue;

  $x=$width*($time-$starttime)/($endtime-$starttime);

  $lastpoints=array();

  //  print "$time $starttime $endtime $x <br>";
  foreach ($minutetypes as $minutetype)
    {
      $mins=$data["minutes"][$minutetype["type"]];

      $usedy=$height-$mins["used"]*$minutetype["scale"];

      // expected minutes
      $data["starttime"]=intval($data["starttime"]);
      $data["endtime"]=intval($data["endtime"]);

      $expmins=$mins["plan"]*($time-$data["starttime"])/
	($data["endtime"]-$data["starttime"]);
      $expy=$height-$expmins*$minutetype["scale"];

      // skip invalid data
      if ($x<0 || $x>$width)
	continue;

      $x=clamp($x,0,$width);
      $usedy=clamp($usedy,0,$height);
      $plany=clamp($plany,0,$height);

      imagelineto($im, $x, $usedy, $minutetype["color"], "used".$minutetype["type"]);

      $bgpattern=array($black,$black,$black,
		       $minutetype["color"], $minutetype["color"], $minutetype["color"]);
      imagesetstyle($im,$bgpattern);
      
      imagelineto($im, $x, $expy,  IMG_COLOR_STYLED, "exp".$minutetype["type"]);
    }
}

header("Content-type: image/png");
imagepng($im);


$ILTCONTEXT=array();
function imagelineto($im, $x, $y, $color, $context)
{
  global $ILTCONTEXT;

  if (isset($ILTCONTEXT[$context]))
    {
      $oldpoint=$ILTCONTEXT[$context];
  
      imageline($im, $oldpoint["x"], $oldpoint["y"], $x, $y, $color);
    }

  $ILTCONTEXT[$context]=array("x"=>$x, "y"=>$y);
}

function maximumscale($data,$type)
{
  $vscale=1;

  foreach ($data as $a)
    {
      if ($a["minutes"][$type]["plan"]>0)
	$cand=$a["minutes"][$type]["used"]/$a["minutes"][$type]["plan"];
      else
	$cand=1;

      if ($cand>$vscale)
	$vscale=$cand;
    }

  return $vscale;
}

function clamp($in, $min, $max)
{
  if ($in>$max)
    return $max;
  if ($in<$min)
    return $min;
  return $in;
}

function maximumminutes($datas, $type)
{
  $maxval=0;

  foreach ($datas as $data)
    {
      $maxval=max($maxval,$data["minutes"][$type]["plan"]);
      $maxval=max($maxval,$data["minutes"][$type]["used"]);
    }

  return $maxval;
}

function maximumplanminutes($datas, $type)
{
  $maxval=0;

  foreach ($datas as $data)
    {
      $maxval=max($maxval,$data["minutes"][$type]["plan"]);
    }

  return $maxval;
}


function readhistoryfile($historypath)
{
  $fd=fopen($historypath,"r");
  if (!$fd)
    {
      die("couldn't open history file");
    }

  $d=array();
  
  if ($debug) 
    print "starting ".time();
  
  while (!feof($fd))
    {
      $line=fgets($fd,8192);
      if (is_string($line))
	{
	  $a=unserialize($line);
	  $d[]=$a;
	}
    }

  return $d;
}
?>